from flask import Flask, jsonify, render_template, request, send_file
import os
import json
import signal
import shutil
import random
from subprocess import check_output

# The interface to bind to (0.0.0.0 means all interfaces)
HOST = "0.0.0.0"
UPLOAD_FOLDER = '/API/upload'

app = Flask(__name__)
app.config['UPLOAD_FOLDER'] = UPLOAD_FOLDER

def getUploadFile():
    return [f for f in os.listdir(app.config['UPLOAD_FOLDER']) if os.path.isfile(os.path.join(app.config['UPLOAD_FOLDER'], f))]

def get_pid(name):
    return int(check_output(["pidof","-s",name]))

def try_make_file(filename):
    try:
        os.open(filename,  os.O_CREAT | os.O_EXCL)
        return True
    except FileExistsError:
        return False

@app.route('/delete/<file>', methods=['DELETE'])
def delete(file):
    filePath = os.path.join(app.config['UPLOAD_FOLDER'], file)
    try:
        os.remove(filePath)
    except:
        return jsonify({'ERROR': 'failed deleting '+file}), 500
    return jsonify({'OK':file+' deleted'}), 200


@app.route('/upload', methods=['POST'])
def upload():
    file = request.files['File']
    filePath = os.path.join(app.config['UPLOAD_FOLDER'], file.filename)
    newFilePath = os.path.splitext(filePath)[0]+'.ppm'
    #print(newFilePath)
    try:
        file.save(filePath)
        os.system("convert "+filePath+" -resize 240x320! "+newFilePath)
        if(os.path.splitext(filePath)[1] != ".ppm"):#si le fichier de base etait deja un ppm
            os.remove(filePath)
    except:
        return jsonify({'ERROR': 'failed uploading '+file.filename}), 500
    return jsonify({'OK':file.filename+' uploaded'}), 200


@app.route('/download/<name>', methods=['GET'])
def download(name):
    try:
        return send_file("/API/upload/"+name)
    except:
        return jsonify({'ERROR': 'Not file to download '}), 500

@app.route('/list', methods=['GET'])
def list():
    str_file = ""
    onlyfiles = getUploadFile()
    #return jsonify(onlyfiles)
    return json.dumps(onlyfiles)

@app.route('/display/<name>', methods=['GET'])
def display(name):
    try:
        os.open("/API/.tmp/to_show.ppm", os.O_CREAT | os.O_EXCL)#atomic test si le fichier existe en le créant
        shutil.copyfile("/API/upload/"+name, "/API/.tmp/"+name)#copie le fichier pas atomic !!!
        #rename est atomic, et vas effacer le fichier crée par le test au dessus
        #en la remplacent par la bonne image a afficher
        os.rename("/API/.tmp/"+name,"/API/.tmp/to_show.ppm")
        #un fois que tout est bon, envoie le signal pour afficher l'image
        os.kill(get_pid("show_image"), signal.SIGUSR1)
    except Exception as e:
        #os.remove(".tmp/"+name)
        return jsonify({'ERROR': 'Cant show image'}), 500
    return jsonify({'OK':'Image '+name+" on screen"}), 200


@app.route('/displayRandom/', methods=['GET'])
def displayRandom():
    lstFiles = getUploadFile()
    if(len(lstFiles)==0):
        return jsonify({'ERROR': 'No Image on folder Upload to show'}), 500
    val=random.randrange(0,len(lstFiles),1)
    return display(lstFiles[val])



if __name__ == "__main__":
    app.run(host=HOST, use_reloader=False, debug=True)
