#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <pthread.h>
#include "nmap_gpio_screen.h"
#include "spi_screen.h"
#include "ppm.h"


#define LOCATION_TO_SHOW "/API/.tmp/to_show.ppm"
int main(int argc, char *argv[])
{
	sigset_t mask;
	int signal;
	//printf("Programme d'ouverture d'image\n");
	int fd;
	void *gpio_base_addr;
	spi_display_t disp;
	img_t *image = NULL;
	int result_sig = 0;
	int result_rm = 0;
	if ((disp.fd_spi = open(SPIDEVNODE, O_RDWR)) == -1)
        pabort("Failed opening SPI device");
	init_pin_screen(&fd, &gpio_base_addr);
	set_cmd_data(0, gpio_base_addr);
	set_backlight(0, gpio_base_addr);
	disp_init(&disp,gpio_base_addr);
	remove(LOCATION_TO_SHOW);
	//signal(SIGINT, handle_sigint);

	sigemptyset(&mask);
	sigaddset(&mask,SIGINT);
	sigaddset(&mask,SIGUSR1);
	pthread_sigmask(SIG_SETMASK, &mask, NULL);
	//sigprocmask( SIG_BLOCK, &signal_set, NULL );

	while(1)
	{
		result_sig = sigwait(&mask,&signal);
		if(result_sig == 0)//sigwait ok
		{
			if(signal == SIGUSR1)
			{
				printf("Affiche Image\n");
				image = load_ppm(LOCATION_TO_SHOW);
				if(image != NULL)
				{
					display_image(image,&disp,gpio_base_addr);
					free_img(image);
					result_rm = remove(LOCATION_TO_SHOW);
				}
				else
				{
					printf("No image Found\n");
				}
				if(result_rm)
				{
					break;
				}
			}
			else//quitte
			{
				break;//quitte le programme
			}
		}
		else//error de sigwait
		{
			break;//quitte le programme
		}
	}
	printf("FIN Programme...\n");
	set_backlight(0, gpio_base_addr);
	set_cmd_data(0, gpio_base_addr);
	printf("CLOSE SPI...\n");
	close(disp.fd_spi);
	printf("free pin...\n");
	free_pin_screen(fd, gpio_base_addr);
	printf("FIN Programme OK\n");
	return 0;
}
